
extern	"C"{
long	versionNumber(LPSTR ver);

long	shareLong(LPCTSTR name, long value);
long	shareLongArray(LPCTSTR name, long dim1, long dim2, long dim3, long* pLongArray);
long	retrieveLong(LPCTSTR name, long* pValue);
long	retrieveLongArray(LPCTSTR name, long dim1, long dim2, long dim3, long* pLongArray);
long	removeLong(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	removeLongArray(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	resetLongSharedMem();
long	resetLongArraySharedMem();

long	shareByte(LPCTSTR name, BYTE value);
long	shareByteArray(LPCTSTR name, long dim1, long dim2, long dim3, BYTE* pByteArray);
long	retrieveByte(LPCTSTR name, BYTE* pValue);
long	retrieveByteArray(LPCTSTR name, long dim1, long dim2, long dim3, BYTE* pByteArray);
long	removeByte(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	removeByteArray(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	resetByteSharedMem();
long	resetByteArraySharedMem();

long	shareDouble(LPCTSTR name, double value);
long	shareDoubleArray(LPCTSTR name, long dim1, long dim2, long dim3, double* pDoubleArray);
long	retrieveDouble(LPCTSTR name, double* pValue);
long	retrieveDoubleArray(LPCTSTR name, long dim1, long dim2, long dim3, double* pDoubleArray);
long	removeDouble(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	removeDoubleArray(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	resetDoubleSharedMem();
long	resetDoubleArraySharedMem();

long	shareString(LPCTSTR name, LPCTSTR pData);
long	retrieveString(LPCTSTR name, long dim, LPSTR pData);
long	removeString(LPCTSTR name, long* numOfShares, long* numOfRetrievals);
long	resetStringSharedMem();

long	maxNumberOfLongBins(long* pMax);
long	maxNumberOfLongArrayBins(long* pMax);
long	maxNumberOfDoubleBins(long* pMax);
long	maxNumberOfDoubleArrayBins(long* pMax);
long	maxNumberOfStringBins(long* pMax);
long	maxNumberOfByteBins(long* pMax);
long	maxNumberOfByteArrayBins(long* pMax);

long	numberOfFreeLongBins(long* pFree);
long	numberOfFreeLongArrayBins(long* pFree);
long	numberOfFreeDoubleBins(long* pFree);
long	numberOfFreeDoubleArrayBins(long* pFree);
long	numberOfFreeStringBins(long* pFree);
long	numberOfFreeByteBins(long* pFree);
long	numberOfFreeByteArrayBins(long* pFree);

long	doesLongNameExist(LPCTSTR name, long* pExist);
long	doesLongArrayNameExist(LPCTSTR name, long* pExist);
long	doesDoubleNameExist(LPCTSTR name, long* pExist);
long	doesDoubleArrayNameExist(LPCTSTR name, long* pExist);
long	doesStringNameExist(LPCTSTR name, long* pExist);
long	doesByteNameExist(LPCTSTR name, long* pExist);
long	doesByteArrayNameExist(LPCTSTR name, long* pExist);

long	numberOfLongNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfLongArrayNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfDoubleNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfDoubleArrayNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfStringNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfByteNameRetrievals(LPCTSTR name, long* pNumber);
long	numberOfByteArrayNameRetrievals(LPCTSTR name, long* pNumber);

long	numberOfLongNameShares(LPCTSTR name, long* pNumber);
long	numberOfLongArrayNameShares(LPCTSTR name, long* pNumber);
long	numberOfDoubleNameShares(LPCTSTR name, long* pNumber);
long	numberOfDoubleArrayNameShares(LPCTSTR name, long* pNumber);
long	numberOfStringNameShares(LPCTSTR name, long* pNumber);
long	numberOfByteNameShares(LPCTSTR name, long* pNumber);
long	numberOfByteArrayNameShares(LPCTSTR name, long* pNumber);

long	numberOfLongNames(long* pNumber);
long	numberOfLongArrayNames(long* pNumber);
long	numberOfDoubleNames(long* pNumber);
long	numberOfDoubleArrayNames(long* pNumber);
long	numberOfStringNames(long* pNumber);
long	numberOfByteNames(long* pNumber);
long	numberOfByteArrayNames(long* pNumber);


long	whatIsLongNameAtIndex(LPSTR name, long indx);
long	whatIsLongArrayNameAtIndex(LPSTR name, long indx);
long	whatIsDoubleNameAtIndex(LPSTR name, long indx);
long	whatIsDoubleArrayNameAtIndex(LPSTR name, long indx);
long	whatIsStringNameAtIndex(LPSTR name, long indx);
long	whatIsByteNameAtIndex(LPSTR name, long indx);
long	whatIsByteArrayNameAtIndex(LPSTR name, long indx);

}//extern "C"


#define	OUT_OF_DOUBLE_MEMORY			100
#define OUT_OF_DOUBLE_ARRAY_MEMORY		101
#define	OUT_OF_LONG_MEMORY				102
#define	OUT_OF_LONG_ARRAY_MEMORY		103
#define	OUT_OF_STRING_MEMORY			104
#define	OUT_OF_BYTE_MEMORY				105
#define	OUT_OF_BYTE_ARRAY_MEMORY		106

#define	DOUBLE_NAME_NOT_FOUND			200
#define	DOUBLE_ARRAY_NAME_NOT_FOUND		201
#define	LONG_NAME_NOT_FOUND				202
#define	LONG_ARRAY_NAME_NOT_FOUND		203
#define	STRING_NAME_NOT_FOUND			204
#define	BYTE_NAME_NOT_FOUND				205
#define	BYTE_ARRAY_NAME_NOT_FOUND		206

#define	INVALID_POINTER					500
#define	TARGET_ARRAY_TOO_SMALL			501
#define	ARRAY_DIMENSION_ERROR			502
#define	INVALID_NAME					503
#define	SHARED_MEM_ERROR				504
#define	INVALID_INDEX					505
#define	NO_NAME_AT_INDEX				506





